﻿using System;
using System.IO;
using System.Web.Mvc;
using OPS_SimpleExample_ASP.Models.Http;

namespace OPS_SimpleExample_ASP.Controllers
{
    public class MainController : Controller
    {
        private SendHttpRequest sendHttpRequest;

        public ActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public ActionResult SendSMS(string apiExtensionId, string sender, string recipient, string message, string deliveryReportURL)
        {
            sendHttpRequest = new SendHttpRequest();
            sendHttpRequest.SendRequest("http://192.168.113.13:7780/", "?Command=SendSms" +
                                                          "&ApiExtension=" + apiExtensionId +
                                                          "&Sender=" + sender +
                                                          "&Recipient=" + recipient +
                                                          "&Message=" + message +
                                                          "&DeliveryReportURL=" + deliveryReportURL);
            return View("Index");
        }

        [HttpPost]  
        public ActionResult MakeCall(string apiExtensionId, string dialed, string callerId, string callerDisplayName, string url, string errorUrl)
        {
            sendHttpRequest = new SendHttpRequest();
            sendHttpRequest.SendRequest("http://192.168.113.13:7780/", "?Command=Call" +
                                        "&Dialed=" + dialed +
                                        "&ApiExtension=" + apiExtensionId +
                                        "&CallerId=" + callerId +
                                        "&CallerDisplayName=" + callerDisplayName +
                                        "&Url=" + url +
                                        "&ErrorUrl=" + errorUrl);
            return View("Index");
        }

        [HttpPost]
        public ActionResult ReceiveCall(string notificationName, string callLegID, string caller, string apiExtension)
        {
            var content = Content(
            "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"+
            "<Response>" +
                "<Speak>Hello " + caller + "!</Speak>" +
            "</Response>"
            );
            content.ContentType = "text/xml";
            return content;
        }

        [HttpPost]
        public void ReceiveSMS(string notificationName, string sender, string recipient, string iD, string apiExtension, string message)
        {
            WriteToFile("c:\\IncomingMessages.txt",

                        "NotificationName:" + notificationName +
                        ";Sender:" + sender +
                        ";Recipient:" + recipient +
                        ";ID:" + iD +
                        ";ApiExtension:" + apiExtension +
                        "Message:" + message + "\n"
                       );
        }

        [HttpPost]
        public ActionResult OutGoingCallResponse()
        {
            var content = Content(
            "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"+
            "<Response>" +
                "<Speak>Hello this is a test call on "+ DateTime.Now.DayOfWeek +". </Speak>" +
            "</Response>"
            );
            content.ContentType = "text/xml";
            return content;
        }

        [HttpPost]
        public void HandleDeliveryReport(string notificationName, string delivered, string iD, string apiExtension)
        {
            WriteToFile("c:\\deliveryReport.txt",

                "NotificationName:" + notificationName +
                ";Delivered:" + delivered +
                ";ID:" + iD +
                ";ApiExtension:" + apiExtension + "\n"
                );
        }

        [HttpPost]
        public void HandleError(string code, string message)
        {
            WriteToFile("c:\\callErrors.txt",

            "Code:" + code +
            ";Message:" + message + "\n"
             );
        }

        private void WriteToFile(string filepath, string content)
        {
            using (var fs = new FileStream(filepath, FileMode.Append, FileAccess.Write, FileShare.Read))
            {
                using (var writer = new StreamWriter(fs))
                {
                    writer.Write(content);

                    writer.Flush();
                    writer.Close();
                }
                fs.Close();
            }
        }
    }
}
